module.exports = function (babel) {
  var t = babel.types;
  var visitors = {
    Function: function (node, parent, scope) {
      if (! node.async) {
        this.skip();
        return;
      }

      node.async = false;

      this.get("body").traverse(visitors);

      node.body = t.blockStatement([
        t.expressionStatement(t.literal("use strict")),
        t.returnStatement(
          t.callExpression(
            t.memberExpression(
              t.identifier("Promise"),
              t.identifier("asyncApply"),
              false
            ),
            [
              t.functionExpression(
                null, // anonymous
                node.params.slice(0),
                node.body
              ),
              t.thisExpression(),
              t.identifier("arguments")
            ]
          )
        )
      ]);
    },

    AwaitExpression: function (node) {
      return t.callExpression(
        t.memberExpression(
          t.identifier("Promise"),
          t.identifier(node.all ? "awaitAll" : "await"),
          false
        ),
        [node.argument]
      );
    }
  };

  return new babel.Transformer("meteor-async-await", visitors);
};
